﻿using Microsoft.Azure.Cosmos.Table;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading.Tasks;

namespace AzureStorage
{
    public class TableStorage<T> : INoSQLStorage<T> where T : TableEntity, new()
    {
        CloudTableClient _cloudTableClient;
        CloudTable _cloudTable;
        public TableStorage()
        {
            CloudStorageAccount cloudStorageAccount = CloudStorageAccount.Parse("AccountName=devstoreaccount1;AccountKey=Eby8vdM02xNOcqFlqUwJPLlmEtlCDXJ1OUzFT50uSRZ6IFsuFq2UVErCz4I6tq/K1SZFPTOtr/KBHBeksoGMGw==;DefaultEndpointsProtocol=http;BlobEndpoint=http://127.0.0.1:10000/devstoreaccount1;QueueEndpoint=http://127.0.0.1:10001/devstoreaccount1;TableEndpoint=http://127.0.0.1:10002/devstoreaccount1;");
            _cloudTableClient = cloudStorageAccount.CreateCloudTableClient();
            _cloudTable = _cloudTableClient.GetTableReference(typeof(T).Name);
            _cloudTable.CreateIfNotExists();
        }
        public async Task<T> Add(T entity)
        {
            TableOperation operation = TableOperation.InsertOrMerge(entity);
            return (await _cloudTable.ExecuteAsync(operation)).Result as T;
        }
        public IQueryable<T> All() => _cloudTable.CreateQuery<T>().AsQueryable();
        public async Task<T> Delete(string rowKey, string partitionKey)
        {
            TableOperation operation = TableOperation.Delete(await Get(rowKey, partitionKey));
            return (await _cloudTable.ExecuteAsync(operation)).Result as T;
        }
        public async Task<T> Get(string rowKey, string partitionKey)
        {
            TableOperation operation = TableOperation.Retrieve<T>(partitionKey, rowKey);
            return (await _cloudTable.ExecuteAsync(operation)).Result as T;
        }
        public IQueryable<T> Query(Expression<Func<T, bool>> query) => _cloudTable.CreateQuery<T>().Where(query);
        public async Task<T> Update(T entity)
        {
            TableOperation operation = TableOperation.Replace(entity);
            return (await _cloudTable.ExecuteAsync(operation)).Result as T;
        }
    }
}
